;;inspired by original by Adesu @ theswamp.org

;;Multiple object selection-(lines, polylines, and arcs) and 'curve' functionality

;;line/text table size determined by textsize variable
;; Paperspace uses dimtxt variable

;;added Autocad Table format
;;cell width determined by method found in Lee Mac's LenCal routine

;;added Paperspace functionality using Giles translation functions
;; (select linework in modelspace from paperspace)

;;Now allows selection of modelspace objects in multiple viewports

;;functions var2list, chord, chord-bearing, replaced, and tan by Mark Thomas

;;Mass-replace inspired by 'replace' by CAB
;;and massoc by Jaysen Long

(defun cvf ( cvf-from cvf-to / )
  (* (nth cvf-from inverseconversionlist)(nth cvf-to conversionlist))
)

(vl-load-com)
(defun lt_dialog (fname / wPath fn)
  (if (not (findfile fname))
    (if (setq wPath (findfile "ACAD.PAT"))
      (progn
        (setq wPath (vl-filename-directory wPath))
        (or (eq "\\" (substr wPath (strlen wPath)))
            (setq wPath (strcat wPath "\\")))
        (setq fn (open (strcat wPath fname) "w"))
        (foreach str
          '("button15 : button   { width = 15; alignment = centered; fixed_width = true; }"
            "button07 : button   { width = 7; alignment = centered; fixed_width = true; }"
            "button04 : button   { width = 4; alignment = centered; fixed_width = true; }"
            "text18 : text   { width = 18; alignment = centered; fixed_width = true; }"
            "text12 : text   { width = 12; alignment = centered; fixed_width = true; }"
            "text10 : text   { width = 10; alignment = centered; fixed_width = true; }"
            "    eBox : edit_box { alignment = centered; fixed_width = true; allow_accept = true;"
            "                      is_tab_stop = true; }"
            "temp : dialog { label = \"LT_LineTable.lsp\";"
            "   :row {"
            "     :popup_list { key = \"Selection0\"; label = \"Select Layer:\"; alignment = left; fixed_width = false; edit_width = 36;}"
            "    }"
            "  :boxed_column { label = \"Labels\";"
            "   :row {"
            "     : text { label = \"Initial #\" ; alignment = Centered; }"
            "     :toggle { key = \"kword\"; label = \"Label Segments\";  alignment = center; }"
            "     : text { label = \"Initial #\" ; alignment = Centered; }"
            "   }"
            "   :row {"
            "     :edit_box { key = \"lcnt\"; alignment = left; edit_limit = 18; edit_width = 18; }"
            "     :text { label = \"              \" ; alignment = Centered; }"
            "     :edit_box { key = \"ccnt\"; alignment = left; edit_limit = 18; edit_width = 18; }"
            "   }"
            " }"
            "  :boxed_column { label = \"Length Conversion and Precision\";"
            "   :row {"
            "   :column {"
            "     spacer;"
            "     :text12 { label = \"Convert From:\";  width = 12; }"
            "     spacer;"
            "     :text12 { label = \"Convert To:\"; width = 12; }"
            "     spacer;"
            "   }"
            "   :column {"
            "   :row {"
            "   :column {"
            "     spacer;"
            "     :text { key = \"FromUnit\";alignment = left; width = 10;}"
            "     :popup_list { key = \"ToUnit\";alignment = left; width = 10; fixed_width = True; }"
            "   }"
            "   :column {"
            "     spacer;"
            "     :text { key = \"CurrPrec\"; width = 10; alignment = left;}"
            "     spacer;"
            "     :popup_list { key = \"ToPrecision\"; alignment = left; width = 10; fixed_width = True;}"
            "   }}"
            "   }}"
            "  }"
            "  :boxed_column { label = \"Title and Header Names/Order\";"
            "   :row {"
            "   :column {"
            "     : text { label = \"           Line Table\" ; alignment = Centered; }"
            "     :edit_box { key = \"LTitle\"; alignment = left; edit_limit = 18; edit_width = 18; }"
            "     :list_box { key = \"Lheaders\"; width = 20; fixed_width = true;  multiple_select = true;}"
            "    }"
            "   :column {"
            "     spacer;"
            "     spacer;"
            "     spacer;"
            "     :button04 { key = \"up\"; label = \"Up\";  }"
            "     :button04 { key = \"down\"; label = \"Dwn\";  }"
            "     :button07 { key = \"del\"   ; label = \"Rmv\" ; }"
            "     spacer;"
            "     spacer;"
            "     spacer;"
            "     spacer;"
            "    }"
            "   :column {"
            "     : text { label = \"          Curve Table\" ; alignment = Centered; }"
            "     :edit_box { key = \"CTitle\"; alignment = left; edit_limit = 18; edit_width = 18; }"
            "     :list_box { key = \"Cheaders\";width = 20; fixed_width = true;  multiple_select = true;}"
            "    }"
            "    }"
            "   :row {"
            "     : button07 { key = \"Lres\"; label = \"Reset\"; }"
            "     : button15 { key = \"Rdef\"; label = \"Restore Defaults\"; }"
            "     : button07 { key = \"Cres\"; label = \"Reset\"; }"
            "   }"
            "  }"
            "  :boxed_radio_row { label = \"Table Format\";"
            "     :radio_button { key = \"Table\"; label = \"Table\"; alignment = left; width = 18; }"
            "     :radio_button { key = \"LTbl\"; label = \"LineText\"; alignment = right; width = 18; }"
            "  }"
            "    : button07 { key = \"accept\"; label = \"Done\"; fixed_width = true ; alignment = centered; is_default = true; is_cancel = true; }"
            "}"
            ""
            "rename : dialog {"
            "label = \"Rename Header\";"
            "  spacer;"
            "  : eBox { key = \"name\"; edit_width = 20; edit_limit = 255; label = \"Header:\"; }"
            "  : errtile { } "
            "  spacer;"
            "  ok_cancel;"
            "}")
          (write-line str fn))
        (close fn)
        t)
    nil)
  t))

(defun MakeUnitList (key)
  (start_list key)
  (mapcar 'add_list unitlist)
  (end_list))

;; WCS2PCS (gile)
;; Translates a point WCS coordinates to the PaperSpace CS according to
;; the specified Viewport
;; 
;; (WCS2PCS pt vp) is the same as (trans (trans pt 0 2) 2 3) when vp is active
;;
;; Arguments
;; pt : a point
;; vp : the viewport (ename or vla-object)

(defun WCS2PCS (pt vp / elst ang nor scl mat)
  (vl-load-com)
  (and (= (type vp) 'VLA-OBJECT)
       (setq vp (vlax-vla-object->ename vp))
  )
  (setq	pt   (trans pt 0 0)
	elst (entget vp)
	ang  (cdr (assoc 51 elst))
	nor  (cdr (assoc 16 elst))
	scl  (/ (cdr (assoc 41 elst)) (cdr (assoc 45 elst)))
	mat  (mxm
	       (list (list (cos ang) (- (sin ang)) 0.0)
		     (list (sin ang) (cos ang) 0.0)
		     '(0.0 0.0 1.0)
	       )
	       (mapcar (function (lambda (v) (trans v nor 0 T)))
		       '((1.0 0.0 0.0) (0.0 1.0 0.0) (0.0 0.0 1.0))
	       )
	     )
  )
  (mapcar '+
	  (vxs (mxv mat (mapcar '- pt (cdr (assoc 17 elst)))) scl)
	  (vxs (cdr (assoc 12 elst)) (- scl))
	  (cdr (assoc 10 elst))
  )
)
;; PCS2WCS (gile)
;; Translates a point PaperSpace coordinates to WCS coordinates
;; according to the specified viewport
(defun PCS2WCS (pt vp / ang nor scl mat)
  (vl-load-com)
  (and (= (type vp) 'VLA-OBJECT)
       (setq vp (vlax-vla-object->ename vp))
  )
  (setq	pt   (trans pt 0 0)
	elst (entget vp)
	ang  (- (cdr (assoc 51 elst)))
	nor  (cdr (assoc 16 elst))
	scl  (/ (cdr (assoc 45 elst)) (cdr (assoc 41 elst)))
	mat  (mxm
	       (mapcar (function (lambda (v) (trans v 0 nor T)))
		       '((1.0 0.0 0.0) (0.0 1.0 0.0) (0.0 0.0 1.0))
	       )
	       (list (list (cos ang) (- (sin ang)) 0.0)
		     (list (sin ang) (cos ang) 0.0)
		     '(0.0 0.0 1.0)
	       )
	     )
  )
  (mapcar '+
	  (mxv mat
	       (mapcar '+
		       (vxs pt scl)
		       (vxs (cdr (assoc 10 elst)) (- scl))
		       (cdr (assoc 12 elst))
	       )
	  )
	  (cdr (assoc 17 elst))
  )
)
;;(gile)
(defun vxs (v s) (mapcar (function (lambda (x) (* x s))) v))
(defun vxv (v1 v2) (apply '+ (mapcar '* v1 v2)))
(defun trp (m) (apply 'mapcar (cons 'list m)))


;; MXV
;; Applies a transformation matrix to a vector  -Vladimir Nesterovsky-
(defun mxv (m v)
  (mapcar '(lambda (r) (vxv r v)) m)
)


;; MXM
;; Multiplies (combinates) two matrices -Vladimir Nesterovsky-
(defun mxm (m q)
  (mapcar '(lambda (r) (mxv (trp q) r)) m)
)

;;(gile)
(defun vxs (v s) (mapcar (function (lambda (x) (* x s))) v))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun vla-list->ssget (vlalist / i ename sset)
  (setq sset (ssadd)
	i -1
  )
  (repeat (length vlalist)
    (setq ename (vlax-vla-object->ename (nth (setq i (1+ i)) vlalist)))
	(setq sset (ssadd ename sset))
  )
);
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun 2dPt->3dPt (pt)(list (float (car pt)) (float (cadr pt)) 0.0))
(defun Pt->2dPt (pt)(list (float (car pt)) (float (cadr pt))))

(defun GetVP ( pt / PIQ vpcoll vp# match vpcords inbounds? center cent viewportlist)
 (setq PIQ (Pt->2dPt pt)
      vpcoll (cdr (vports))
 )
 (foreach x vpcoll
    (setq vpcords (cdr x)
          inbounds?
      	    (mapcar
              '(lambda (cords)
          	 (mapcar '(lambda (cordspt apt)(- cordspt apt)) cords piq)
               )
      	      vpcords
      	    )
    )
   (and
     (not (vl-remove-if 'minusp (list (cadar inbounds?)(caar inbounds?))))
     (not (vl-remove-if-not 'minusp (list (caadr inbounds?)(cadadr inbounds?))))
     (setq center (2dPt->3dPt (mapcar '(lambda (a b) (/ (+ a b) 2.0)) (car vpcords)(cadr vpcords))))
     (vlax-for i (vla-get-paperspace ActDoc)
	   (and 
	      (member (vla-get-objectname i) '("AcDbViewport"))
	      (setq cent (vlax-safearray->list (vlax-variant-value (vla-get-center i))))
	      (not (member nil (mapcar '(lambda (a b)(= a b)) cent center)))
	      (setq viewportlist (append viewportlist (list i)))
	   )
     )
   )
 )
   (if (> (length viewportlist) 1)		
		(nth
		  (vl-position
		    (apply 'min
		      (setq minlist
			(mapcar '(lambda (x) (vla-get-height x)) viewportlist)
		       )
		     )
		    minlist
		   )
		  viewportlist
		 )
		(car viewportlist)
   );if
				  
)


(defun SOFP (/ pt obj)
  (if (setq pt (getpoint "\nSelect Object: "))
    (if (nentselp pt)
	(progn
		(princ "\nObject is not in modelspace.Try again.")
		(sofp)
	);
	(if (setq viewport (getvp pt))
  	  (progn
	    (vla-put-mspace ActDoc :vlax-true)
       	    (vla-put-activepviewport ActDoc viewport)
       	    (vl-cmdf "ucs" "w")
	    (setq obj (nentselp (pcs2wcs pt viewport)))
	    (if (> (length obj) 2)
		(setq obj (caar (reverse obj)))
		(setq obj (car obj))
	    )
       	    (vla-put-mspace ActDoc :vlax-false)
	    (if obj
	      (vlax-ename->vla-object obj)
	      (progn
		  (princ "\nMissed Object! Try again.")
		  (sofp)
	       )
	     )
  	  )
   	  (progn
	    (princ "\nPoint selected is outside viewport(s)!\nTry again.")
	    (sofp)
	  )
	)
    )
  )
)


(defun PSSel (/ n obj ss postn vpss AMspace count)
(setq AMspace (vla-get-modelspace ActDoc))
(setq count 0)
	(if (and (= (vla-get-ActiveSpace ActDoc) 0)
		 (eq (vla-get-mspace ActDoc) :vlax-false)
            )
	       (while
	         (setq obj (sofp))
		  (setq count (1+ count))
		   (if (acet-sys-shift-down)	
			(and ss
			  (setq postn (vl-position obj ss))
			  (if (= (length ss) 1)
			      (progn (setq ss nil vplist nil)
				(vla-highlight obj :vlax-false)
			      )
			      (progn (setq ss (vl-remove obj ss) vplist (vl-remove (nth postn vplist) vplist))
				(vla-highlight obj :vlax-false)
			      );
			   )
			)
			(cond
			  (ss 
			    (if (member obj ss) (vla-highlight obj :vlax-true)
				(progn (setq ss (append ss (list obj))
					     vplist (append vplist (list (cons count viewport)))
					)
					(vla-highlight obj :vlax-true)
				)
			     );if
			   )
			  ((not ss)
		   		(setq ss (append ss (list obj))
				      vplist (append vplist (list (cons count viewport)))
				)
				(vla-highlight obj :vlax-true)
			  )
			);cond
		   )
	       )

	    (setq ss (ssget '((-4 . "<OR")(0 . "*POLYLINE")(0 . "ARC")(0 . "LINE")(-4 . "OR>"))))
	)
  (if (listp ss)
    (progn
      (foreach i ss (vla-highlight i :vlax-false))
      (vla-list->ssget ss)
    );
    ss
  )
)

(defun Var2List (var)
  (vlax-safearray->list
    (vlax-variant-value var)
    )
  )

(defun chord (obj)
  (distance
    (var2list (vla-get-StartPoint obj))
    (var2list (vla-get-EndPoint obj))
    )
  )

(defun chord-bearing (obj)
    (angle
      (var2list (vla-get-StartPoint obj))
      (var2list (vla-get-EndPoint obj))
      )
  )

(defun ReplaceD (str)
  (vl-string-subst "" "d" str)
  )


(defun tan (ang)
  (/ (sin ang) (cos ang))
)


(defun massoc (key alist / x nlist)
  (foreach x alist
     (if
         (eq key (car x))
         (setq nlist (cons (cdr x) nlist))
      )
   )
  (reverse nlist)
);defun

(defun hascurve (ent / pl)
    (and (or
	   (/= (type ent) 'VLA-OBJECT)
	   (setq obj (vlax-vla-object->ename ent))
	  );or
	(setq pl (massoc 42 (entget obj)))
	(or (> (apply 'max pl) 0.0)
            (< (apply 'min pl) 0.0)
        )
    )
);

(defun mass-replace (alist key itmlst / i)
(setq i -1)
(mapcar 
  '(lambda (x)
    (if (eq (car x) key)
      (cons (car x)(nth (setq i (1+ i)) itmlst))
       x
    )
  )
  alist
)
) 

;;  Ptr->L   (Lee Mac)                           ;;
;; ~ Converts a DCL List_Box Selection $value      ;;
;;   into a list.                                  ;;

(defun Ptr->L (ptr)
  (read (strcat "(" ptr ")")))


;;  L->Ptr   (Lee Mac)                           ;;
;; ~ Converts a list to a DCL List_box Selection   ;;
;;   $value.                                       ;;

(defun L->Ptr (lst)
  (vl-string-trim "()"
    (vl-princ-to-string lst)))

;;  Makelst   (Lee Mac)        ;;
;; ~ Populates a list DCL tile.  ;;

(defun Makelst (key lst)
  (start_list key)
  (mapcar 'add_list lst)
  (end_list))


;;  Remove_nth   (Lee Mac)          ;;
;; ~ Removes the nth item in a list.  ;;

(defun Remove_nth (i lst / j)
  (setq j -1)
  (vl-remove-if
    (function
      (lambda (x)
        (eq i (setq j (1+ j))))) lst))


;;  Remove_lst   (Lee Mac)          ;;
;; ~ Removes items from a list if     ;;
;;   their index appears in a list    ;;

(defun Remove_lst (ilst lst)
  (setq j -1)
  (vl-remove-if
    (function
      (lambda (x)
        (vl-position (setq j (1+ j)) ilst))) lst))
;;  MoveUp   (Lee Mac)                  ;;
;; ~ Moves the nth item in a list to the  ;;
;;   (n-1)th position.                    ;;

(defun MoveUp (i lst / j)
  (setq j -1)
  (cond ((zerop i) lst)
        ((mapcar
           (function
             (lambda (x)
               (setq j (1+ j))
               (cond ((eq j (1- i)) (nth i lst))
                     ((eq j i)      (nth (1- i) lst))
                     (x)))) lst))))


;;  List_up   (Gile)                        ;;
;; ~ Moves the items at the indexes provided  ;;
;;   to the (n-1)th positions, unless in      ;;
;;   consecutive 0,1,2...n positions.         ;;

(defun List_Up (ind lst)
  (cond (  (or (null ind) (null lst)) lst)
        (  (= 0  (car ind))
           (cons (car lst)  (list_up (cdr (mapcar '1- ind)) (cdr lst))))
        (  (= 1  (car ind))
           (cons (cadr lst) (list_up (cdr (mapcar '1- ind)) (cons (car lst) (cddr lst)))))
        (t (cons (car lst)  (list_up (mapcar '1- ind) (cdr lst))))))


;;  MoveDown   (Lee Mac)                ;;
;; ~ Moves the nth item in a list to the  ;;
;;  (n+1)th position.                     ;;

(defun MoveDown (i lst / j)
  (setq j -1)
  (cond ((eq (1- (length lst)) i) lst)
        ((mapcar
           (function
             (lambda (x)
               (setq j (1+ j))
               (cond ((eq j i)      (nth (1+ i) lst))
                     ((eq j (1+ i)) (nth i lst))
                     (x)))) lst))))


;;  List_Down   (Lee Mac)                   ;;
;; ~ Moves the items at the indexes provided  ;;
;;   to the (n+1)th positions, unless in      ;;
;;   consecutive n,(n-1),(n-2)...0 positions. ;;

(defun List_Down (ind lst)
  (reverse
    (list_up
      (reverse
        (mapcar
          (function
            (lambda (x)
              (- (1- (length lst)) x))) ind))
      (reverse lst))))  


;;  toTop   (Lee Mac)                   ;;
;; ~ Moves the nth item in a list to the  ;;
;;   0th position.                        ;;

(defun toTop (i lst)
  (cond ((zerop i) lst)
        ((append (list (nth i lst))
                 (remove_nth i lst)))))


;;  List_to_Top   (Lee Mac)              ;;
;; ~ Moves the items in a list of indexes  ;;
;;   to the 0th position.                  ;;

(defun List_to_Top (ilst lst)
  (append (mapcar
            (function
              (lambda (i)
                (nth i lst))) ilst)
          (Remove_lst ilst lst)))


;;  toBottom   (Lee Mac)                ;;
;; ~ Moves the nth item in a list to the  ;;
;;   last position                        ;;

(defun toBottom (i lst)
  (cond ((eq (1- (length lst)) i) lst)
        ((append (remove_nth i lst)
                 (list (nth i lst))))))


;;  List_to_Bottom   (Lee Mac)           ;;
;; ~ Moves the items in a list of indexes  ;;
;;   to the nth position.                  ;;

(defun List_to_Bottom (ilst lst)
  (append (Remove_lst ilst lst)
          (mapcar
            (function
              (lambda (i)
                (nth i lst))) ilst)))

(defun header_rename (i lst / headern) 
                                       
  (cond ((not (new_dialog "rename" dcl_id))
         (cond (et (acet-ui-message "Error Loading Rename Dialog" "Warning" 16))
               (t  (princ "\n** Error Loading Rename Dialog **")))
         lst)

        (t
         (set_tile "name" (nth i lst))
         (mode_tile "name" 2)

         (action_tile "name"
           (vl-prin1-to-string (set_tile "error" "")))

         (action_tile "accept"
           (vl-prin1-to-string
             (quote
               (progn
                 (setq headern (get_tile "name"))
                 (cond ((vl-position (strcase headern)
                        (mapcar 'strcase (Remove_nth i lst)))
                        (set_tile "error" (strcat headern " already exists!"))
                        (mode_tile "name" 2)
                        (setq tab nil))
                       
                       (t (done_dialog)))))))
                                                                      
         (action_tile "cancel" "(done_dialog)")   

         
         (start_dialog)

         (if headern
           (if (eq headern (nth i lst))
	       lst
               (subst headern (nth i lst) lst)
           ) lst))))

(defun GetCWidth (Header stringposition listofstringlists / )
 (+
  (sqrt
   (-
    (expt
     (apply 'max
      (mapcar
       (function (lambda (x)(distance (car x)(cadr x))))
       (cons
        (textbox (list (cons 1 Header)(assoc 41 sty)))
        (mapcar
         (function (lambda (y) (textbox (list (cons 1 (nth stringposition y))(assoc 41 sty)))))
         listofstringlists
        )
       )
      )
     )
     2.0
    )
    (expt ts 2)
   )
  )
  (*  ts (cdr (assoc 41 sty)))
 )
)

(defun acwidthlist (wlist / acwlist wlist2)
 (setq wlist2 wlist)
 (repeat (length wlist)
  (setq acwlist (cons (apply '+ wlist2) acwlist)
        wlist2 (reverse (cdr (reverse wlist2))))
 )
 acwlist
)

(defun LCAddLtTable (comparelist Title HeaderList listoflists / *Space* ts sty n p0 p1 p2 el1 dl cmpt oset wlist acwlist linelist )
 (setq *Space* (vlax-get-property ActDoc (nth (vla-get-ActiveSpace ActDoc)'("PaperSpace" "ModelSpace")))
        sty (tblsearch "Style" (getvar 'textstyle))
        n 0)
 (if (eq (setq ts (cdr (assoc 40 sty))) 0.0) (setq ts (getvar 'textsize)))
 (repeat (length comparelist)
   (setq wlist  (cons (GetCWidth (nth n HeaderList) (nth n comparelist) listoflists) wlist) 
         n (1+ n))
 )
 (setq wlist (reverse wlist)
       p0 (getpoint "\nSelect point to place table: ")
       p1 (polar p0 0 (apply '+ wlist))
 )
 (setq el1 (vla-addline *Space* (vlax-3d-point p0) (vlax-3d-point p1)))
 (vla-ArrayRectangular el1 (+ (length listoflists) 3.0) 1.0 1.0 (* -2.5 ts) 0.0 0.0)
 (setq dl (* (+ (length listoflists) 2) (* 2.5 ts))
       p2 (polar p0 (* pi 1.5) dl)
       el1 (vla-addline *Space* (vlax-3d-point p0)(vlax-3d-point p2))
       n 0)
 (setq linelist (list (setq el1 (vla-addline *Space* (vlax-3d-point (polar p0 (* pi 1.5) (* 2.5 ts)))(vlax-3d-point p2)))))
 (repeat (length wlist)
  (and
   (nth n wlist)
   (vla-ArrayRectangular el1 1.0 2.0 1.0 0.0 (nth n wlist) 0.0)
   (setq el1 (vlax-ename->vla-object (entlast))
         n (1+ n)
   )
   (setq linelist (append linelist (list el1)))
  )
 )
 (mapcar 'vla-delete (list (car linelist)(car (reverse linelist))))
 (vla-addline *Space* (vlax-3d-point p1)(vlax-3d-point (polar p2 0 (apply '+ wlist))))
 (setq p2 (polar p0 (* pi 1.5) (* 6.25 ts))
       p2 (polar p2 0 (*  ts 0.5 (cdr (assoc 41 sty))))
       n 0
       cmpt 0
       oset (* ts -0.5)
 )
(setq acwlist (acwidthlist wlist))
 (repeat (length listoflists)
  (repeat (length comparelist)
    (setq tloc (list
                 (car (polar p2 0 (- (nth n acwlist)(nth n wlist))))
                 (+ (cadr (polar p2 0 (- (nth n acwlist)(nth n wlist)))) oset)
               )
          str (nth (nth n comparelist) (nth cmpt listoflists))
          n (1+ n)
    );setq
    (vla-addtext *Space* str (vlax-3d-point tloc) ts) 
  )
  (setq cmpt (1+ cmpt)
        oset (- oset (* 2.5 ts))
        n 0)
 )
 (setq p0 (polar p0 (* pi 1.5) (* 1.75 ts))
       p0 (polar p0 0 (*  ts 0.5 (cdr (assoc 41 sty))));;;
        n 0
 );setq
(vla-addtext *Space* Title
  (vlax-3d-point
    (polar p0 0
      (- (/ (car (reverse acwlist)) 2)
         (/ (car (mapcar (function (lambda (x)(distance (car x)(cadr x))))(list (textbox (list (cons 1 Title)(assoc 41 sty)))))) 2)
      )
    )
  )
  ts
)
(setq p0 (polar p0 (* pi 1.5) (* 2.5 ts)))
(repeat (length comparelist)
    (vla-addtext *Space* (nth n HeaderList)
                         (vlax-3d-point (polar p0 0 (- (nth n acwlist)(nth n wlist))))
                         ts)
    (setq n (1+ n))
)
);defun 
(defun LCAddTable (comparelist Title Titlelist listoflists / ActDoc *Space* ts i n p0 wlist ots sty)
 (setq ActDoc (vla-get-ActiveDocument (vlax-get-Acad-Object))
       *Space* (vlax-get-property ActDoc (nth (vla-get-ActiveSpace ActDoc)'("PaperSpace" "ModelSpace")))
       sty (tblsearch "Style" (getvar 'textstyle))
       ots (getvar 'textsize)
       ts (vla-gettextheight (vla-item (vla-item (vla-get-dictionaries ActDoc) "ACAD_TABLESTYLE") "Standard") acDataRow))
       (setvar 'textsize ts)
(setq p0 (getpoint "\nSelect point to place table: ")
      tblObj
       (vla-addTable *Space*
         (vlax-3D-point p0)
         (+ (length listoflists) 2.0) 
         (length comparelist)
         (* 2.5 ts)
         (* 50 ts)
       )
      n 0
 );setq 
(vla-put-regeneratetablesuppressed tblobj :vlax-true)
(vla-put-StyleName tblObj "Standard")
(vla-setText tblObj 0 0 Title)

 (repeat (length comparelist)
   (setq wlist (cons (GetCwidth (nth n titlelist) (nth n comparelist) listoflists) wlist))
   (vla-setText tblobj 1 n (nth n Titlelist))
   (setq n (1+ n))
 )
(setq wlist (reverse wlist) i 2 n 0)

 (foreach x listoflists
  (repeat (length comparelist)
    (vla-setText tblobj i n (nth (nth n comparelist) x))
    (setq n (1+ n))
  )
  (setq n 0 i (1+ i))
 )

(setq i -1)
(mapcar
 '(lambda (x)
   (vla-setcolumnwidth tblobj (setq i (1+ i)) x)
 )
 wlist
)
(vla-put-regeneratetablesuppressed tblobj :vlax-false)
(setvar 'textsize ots)
);defun 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;LT_LINE-TABLE.LSP;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun c:lt ()(c:linetable))

(defun c:linetable ( / ActDoc obj param endparam blg delta arcparam *error*  oerror ts viewport
			ss n kword sinfo plist typ pt1 arcparam txtpt lyr fname
			delta pt2 y2 y x2 x c s rad cc a midp cen ang xang tangent LresCompLst
			dist ls xlst cls cxlst *Space* ol kword oldts vplist CresCompLst
			p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16 lreslst creslst
			unitlist conversionlist inverseconversionlist insu fname
		)
 
(defun *error* ( msg)
        (princ (strcat "\n<" msg ">\n"))
	(setq *error* oerror)
	(setvar "osmode" (boole 2 (getvar "osmode") 16384))
	(setvar "clayer" ol)
        (setvar 'textsize oldts)
	(vla-EndUndoMark ActDoc)
        (princ)
);defun *error*
(setq fname "Ltv16.dcl")
(setq ActDoc (vla-get-ActiveDocument (vlax-get-Acad-Object)))
(vla-EndUndoMark ActDoc)
(vla-StartUndoMark ActDoc)
(setq oldts (getvar 'textsize))
(or LTitle (setq LTitle "LINE TABLE"))
(or CTitle (setq CTitle "CURVE TABLE"))
(or llst (setq llst (list "ID" "BEARING" "LENGTH" "START PT" "END PT")))
(or LCompLst (setq LCompLst (list 0 1 2 3 4)))
(or clst (setq clst (list "ID" "RADIUS" "LENGTH" "DELTA" "BEARING" "CHORD LENGTH" "START PT" "END PT")))
(or CComplst (setq Ccomplst (list 0 1 2 3 4 5 6 7)))
(setq ni (if (not lcnt) 1 (+ ni lcnt)))
(setq ci (if (not ccnt) 1 (+ ci ccnt)))
(if (and (= (vla-get-ActiveSpace ActDoc) 0)(eq (vla-get-mspace ActDoc) :vlax-false)) (setvar 'textsize (getvar 'dimtxt)))
(setq 
      ts (getvar "textsize")
      ol (getvar "clayer")
);setq

	 (setq ss (pssel)
		n 0
    	);

(lt_dialog fname)
(setq dcl_id (load_dialog fname))
(or (new_dialog "temp" dcl_id)(exit))
(if (= kword2 "Table")(set_tile "Table" "1")(set_tile "LTbl" "1"))

(setq  Unitlist (list "Inches" "Feet" "Yards" "Miles"
                       "Millimeters" "Centimeters" "Meters" "Kilometers" "Microinches"
                       "Mils" "Angstroms" "Nanometers"
                       "Microns" "Decimeters" "Dekameters" "Hectometers"
                       "Gigameters" "Astro Units" "Light Years" "Parsecs")
        conversionlist
           (list
             1;                             ;Inch 1
             (/ 1.0 12)                     ;Foot 2
             (/ 1.0 (* 3 12))               ;Yard 10
             (/ 1.0 (* 5280 12))            ;Mile 3
             (* 10.0 2.54)                  ;Millimeter 4
             2.54                           ;Centimeter 5
             (* (expt 10.0 -2) 2.54)        ;Meter 6
             (* (expt 10.0 -5) 2.54)        ;Kilometer 7
             (expt 10.0 6)                  ;Microinch 8
             (expt 10.0 3)                  ;Mil 9
             (* (expt 10.0 8) 2.54)         ;Angstrom 11
             (* (expt 10.0 7) 2.54)         ;Nanometer 12
             (* (expt 10.0 4) 2.54)         ;Micron 13
             (* (expt 10.0 -1) 2.54)        ;Decimeter 14
             (* (expt 10.0 -3) 2.54)        ;Dekameter 15
             (* (expt 10.0 -4) 2.54)        ;Hectometer 16
             (* (expt 10.0 -11) 2.54)       ;Gigameter 17
             (* (expt 10.0 -13) 1.69788366) ;Astronomical Unit 18
             (* (expt 10.0 -18) 2.68483946) ;Light Year 19
             (* (expt 10.0 -19) 8.23157228) ;Parsec 20
         )
       inverseconversionlist
        (mapcar
          (function
            (lambda (x) (/ 1.0 x))
          )
         conversionlist
        ))
(setq insu (getvar 'insunits) ConvertFrom
(cond ((member insu '(0 1)) 0)((= insu 2) 1)((< insu 10) insu)((= insu 10)  2)((> insu 10) (1- insu))))
(or ConvertTo (setq ConvertTo ConvertFrom))
(mapcar 'MakeUnitList '("ToUnit"))

 (setq 
         LresLst llst
         CresLst clst
         LresCompLst LCompLst
         CresCompLst CCompLst
         kword "Yes"
         layers (cons (getvar "clayer")(acad_strlsort (ai_table "layer" 4))))
         (set_tile "CurrPrec" (strcat "  " (rtos 0)))
	 (set_tile "LTitle" LTitle)
         (set_tile "CTitle" CTitle)      
	 (start_list "Selection0")
	 (mapcar 'add_list layers)
	 (end_list)
         (start_list "Lheaders")
         (mapcar 'add_list llst)
         (end_list)
	 (start_list "Cheaders")
	 (mapcar 'add_list clst)
	 (end_list)
	 (set_tile "kword" "1")
	 (set_tile "lcnt" (itoa ni))
	 (set_tile "ccnt" (itoa ci))
	 (mode_tile "lcnt" 0)
	 (mode_tile "ccnt" 0)

(and
  ConvertFrom (set_tile "FromUnit" (nth ConvertFrom Unitlist))
  ConvertTo (set_tile "ToUnit" (itoa ConvertTo))
  (setq CVFactor (CVF ConvertFrom ConvertTo))
)

(mapcar
    (function (lambda (x)
      (start_list x)
      (mapcar 'add_list (list "0" "0.0" "0.00" "0.000" "0.0000" "0.00000" "0.000000" "0.0000000" "0.00000000"))
      (end_list)
    ))
    (list "ToPrecision")
  )

(or ToPrecision (setq ToPrecision (itoa (getvar 'luprec))))
(set_tile "ToPrecision" ToPrecision)


(action_tile "ToUnit"
  (vl-prin1-to-string
    (quote
      (progn
        (setq ConvertTo (fix (atof $value)))
        (setq CVFactor (CVF ConvertFrom ConvertTo))
      ))))

(action_tile "ToPrecision"
  (vl-prin1-to-string
    (quote
      (progn
        (setq ToPrecision $value)
      ))))

         (action_tile "kword"
           (vl-prin1-to-string
             (quote
               (progn
                 (setq kword (if (eq $value "1") "Yes" "No"))

               ))))
         (action_tile "lcnt"
           (vl-prin1-to-string
             (quote
                 (setq ni (atoi $value))
               )))
         (action_tile "ccnt"
           (vl-prin1-to-string
             (quote
                 (setq ci (atoi $value))
               )))
         (action_tile "Table"
           (vl-prin1-to-string
             (quote
               (progn
                 (setq kword2 (if (eq $value "1") "Table" "LineText"))
               ))))
         (action_tile "LTbl"
           (vl-prin1-to-string
             (quote
               (progn
                 (setq kword2 (if (eq $value "1") "LineText" "Table"))
               ))))
         (action_tile "SFactor" "(setq SFactor (atof $value))")
         (action_tile "LTitle" "(setq LTitle $value)")
         (action_tile "CTitle" "(setq CTitle $value)")
         (action_tile "Lheaders"
           (vl-prin1-to-string
             (quote
               (progn
                 (setq #st (getvar "DATE") ptr (get_tile "Lheaders"))
                 (Makelst "Cheaders" clst)
                 (setq check 0)
                 (if (and (eq dbptr (get_tile "Lheaders"))
                          (< (abs (read (rtos (- #en #st) 2 10))) 0.0000011667))
                   (progn
                     (Makelst "Lheaders" (setq llst (header_rename (atoi ptr) llst)))
                     (setq dbptr nil)
                     (set_tile "Lheaders" ptr)
                   )
                   (setq #en (getvar "DATE") dbptr (get_tile "Lheaders")))))))

         (action_tile "Cheaders"
           (vl-prin1-to-string
             (quote
               (progn
                 (setq #st (getvar "DATE") ptr (get_tile "Cheaders"))
                 (Makelst "Lheaders" llst)
                 (setq check 1)
                 (if (and (eq dbptr (get_tile "Cheaders"))
                          (< (abs (read (rtos (- #en #st) 2 10))) 0.0000011667))
                   (progn
                     (Makelst "Cheaders" (setq clst (header_rename (atoi ptr) clst)))
                     (setq dbptr nil)
                     (set_tile "Cheaders" ptr)
                   )
                   (setq #en (getvar "DATE") dbptr (get_tile "Cheaders")))))))

         (action_tile "up"
           (vl-prin1-to-string
             (quote
	 (if (eq check 0)
                 (progn 
                   (setq oldptr (mapcar '(lambda (x)(nth x llst))(Ptr->L ptr)))
                   (Makelst "Lheaders"  (setq llst (List_Up (Ptr->L ptr) llst)))
		   (setq LCompLst (List_Up (Ptr->L ptr) LCompLst))
                   (set_tile "Lheaders" (setq ptr (L->Ptr (mapcar '(lambda (x) (vl-position x llst)) oldptr))))
                 )
                 (progn 
                   (setq oldptr (mapcar '(lambda (x)(nth x clst))(Ptr->L ptr)))
                   (Makelst "Cheaders"  (setq clst (List_Up (Ptr->L ptr) clst)))
		   (setq CCompLst (List_Up (Ptr->L ptr) CCompLst))
                   (set_tile "Cheaders" (setq ptr (L->Ptr (mapcar '(lambda (x) (vl-position x clst)) oldptr))))
                 )
	 ))))
         
         (action_tile "down"
           (vl-prin1-to-string
             (quote
	 (if (eq check 0)
                 (progn 
                   (setq oldptr (mapcar '(lambda (x)(nth x llst))(Ptr->L ptr)))
                   (Makelst "Lheaders"  (setq llst (List_Down (Ptr->L ptr) llst)))
		   (setq LCompLst (List_Down (Ptr->L ptr) LCompLst))
                   (set_tile "Lheaders" (setq ptr (L->Ptr (mapcar '(lambda (x) (vl-position x llst)) oldptr))))
                 )
                 (progn 
                   (setq oldptr (mapcar '(lambda (x)(nth x clst))(Ptr->L ptr)))
                   (Makelst "Cheaders"  (setq clst (List_Down (Ptr->L ptr) clst)))
		   (setq CCompLst (List_Down (Ptr->L ptr) CCompLst))
                   (set_tile "Cheaders" (setq ptr (L->Ptr (mapcar '(lambda (x) (vl-position x clst)) oldptr))))
                 )
	 ))))

         (action_tile "del"
           (vl-prin1-to-string
             (quote
               (if (eq check 0)
		 (progn
                   (setq oldptr (Ptr->L ptr))
                   (Makelst "Lheaders" (setq llst (remove_lst oldptr llst)))
		   (setq LCompLst (remove_lst oldptr LComplst))
                   (set_tile "Lheaders" ptr)
                  )
                 (progn 
                   (setq oldptr (Ptr->L ptr))
                   (Makelst "Cheaders" (setq clst (remove_lst oldptr clst)))
		   (setq CCompLst (remove_lst oldptr CComplst))
                   (set_tile "Cheaders" ptr)
                  )
               ))))

         (action_tile "Lres"
           (vl-prin1-to-string
             (quote
               (progn
                 (Makelst "Lheaders" (setq llst LresLst))
		 (setq LComplst LresCompLst)
               ))))

         (action_tile "Cres"
           (vl-prin1-to-string
             (quote
               (progn
                 (Makelst "Cheaders" (setq clst CresLst))
		 (setq CComplst CresCompLst)
               ))))

         (action_tile "Rdef"
           (vl-prin1-to-string
             (quote
               (progn
		 (setq LTitle "LINE TABLE")
	         (set_tile "LTitle" LTitle)
                 (setq CTitle "CURVE TABLE")  
                 (set_tile "CTitle" CTitle)
                 (setq llst (list "ID" "BEARING" "LENGTH" "START PT" "END PT"))
                 (setq LresLst llst)
                 (Makelst "Lheaders" llst)
                 (setq LComplst (list 0 1 2 3 4))
                 (setq LresCompLst LCompLst)
                 (setq clst (list "ID" "RADIUS" "LENGTH" "DELTA" "BEARING" "CHORD LENGTH" "START PT" "END PT"))
                 (setq CresLst clst)
                 (Makelst "Cheaders" clst)
		 (setq CComplst (list 0 1 2 3 4 5 6 7))
                 (setq CresCompLst CCompLst)
               ))))

         (action_tile "accept"
           (vl-prin1-to-string
             (quote
               (progn
                 (setq lyr (atof (get_tile "Selection0")))
		 (done_dialog)
               ))))

         (start_dialog)
         (unload_dialog dcl_id)

(setq lyr (fix lyr) lyr (nth lyr layers))
(setvar "clayer" lyr)

(setq ccnt 0
	lcnt 0
	*Space* (vlax-get-property ActDoc (nth (vla-get-ActiveSpace ActDoc)'("PaperSpace" "ModelSpace")))

);setq

(if (and (= (vla-get-ActiveSpace ActDoc) 0)(eq (vla-get-mspace ActDoc) :vlax-true)) (Setq *Space* (vlax-get-property ActDoc "ModelSpace")))
(setvar "osmode" (boole 7 (getvar "osmode") 16384))
(repeat (sslength ss)

(setq obj (ssname ss n))
(and vplist (setq viewport (cdr (nth n vplist))))
(setq n (1+ n))


(cond
	((and (hascurve obj)
	     (setq obj (vlax-ename->vla-object obj))
	     (setq typ (vlax-get obj 'ObjectName))
	     (or (= typ "AcDb2dPolyline") (= typ "AcDbPolyline")(= typ "AcDbLWPolyline"))
	)

	(progn
		(setq sinfo (entget (vlax-vla-object->ename obj)))
		(setq plist (massoc 10 sinfo))
	  	(setq param 0
          		endparam (vlax-curve-getEndParam obj)
    	  	);setq 
		(and (vlax-curve-isclosed obj)(setq plist (append plist (list (car plist)))))
 		(while (<= param endparam);;while param is less than # of segs
	   		(if
        			(and 
          				(/= param endparam)
          				(setq blg (abs (vlax-invoke obj 'GetBulge param)))
          				(/= 0 blg)
        			)

        			(progn
          				(setq delta (* 4 (atan blg))
						pt1 (nth param plist)
						pt2 (nth (1+ param) plist)
            				);setq
					(setq y2 (cadr pt2)
             					 y (cadr pt1)
	      					x2 (car pt2)
	      					x  (car pt1)
	      					c (sqrt (+ (expt (- y2 y) 2)(expt (- x2 x) 2)))
	      					s (abs (* (/ c 2) blg))
                                        )
                                        (if (not (zerop s))
                                        (setq
	      					rad (/ (+ (expt s 2)(expt (/ c 2) 2))(* s 2)) 
              					cc  (/ c 2.0)
	      					a (sqrt (- (expt rad 2.0) (expt cc 2.0)))
     	      					midp (polar pt1 (angle pt1 pt2) cc)
						arcparam (+ param 0.5)
						txtpt (vlax-curve-getPointAtParam obj arcparam)
	      					ang delta
						xang (angle pt1 pt2)
						dis (/ (* 2 pi rad ang) (* 2 pi))
						ccnt (1+ ccnt)
						cls (list
                                                         (strcat "C" (itoa (+ (1- ci) ccnt)))
                                                         (rtos (* rad CVFactor) 2 (atoi ToPrecision))
                                                         (rtos (* dis CVFactor) 2 (atoi ToPrecision)) 
                                                         (ReplaceD (angtos ang 1 4))
                                                         (ReplaceD (angtos xang 4 3))
                                                         (rtos (* c CVFactor) 2 (atoi ToPrecision))
                                                         (strcat "N " (rtos y) ", E " (rtos x))
                                                         (strcat "N " (rtos y2) ", E " (rtos x2))
                                                     )
						cxlst (append cxlst (list cls))
					);setq
                                        )
					(and (= kword "Yes")(not (zerop s))
					    (Setq Tobj
					      (vla-AddMtext *Space*
						(setq txtpt
					          (vlax-3d-point
						    (if (and (= (vla-get-ActiveSpace ActDoc) 0)(eq (vla-get-mspace ActDoc) :vlax-false))
							(polar (setq txtpt (wcs2pcs txtpt viewport)) (angle (wcs2pcs midp viewport) txtpt)(* 3 (getvar 'dimtxt)))
							(polar txtpt (angle midp txtpt)(* 3 ts))
					            )
					          )
						);setq txtpt
						0.0
						(strcat "C" (itoa (+ (1- ci) ccnt)))
					      )
					    )
					    (vla-put-attachmentpoint Tobj acAttachmentPointMiddleCenter)
					    (vla-put-insertionpoint Tobj txtpt)
					  );and
        			);progn
				(if
				(and 
          				(/=  param endparam)
          				(setq blg (abs (vlax-invoke obj 'GetBulge param)))
          				(= 0 blg)
        				)
				(progn
					(setq pt1 (nth param plist)
						pt2 (nth (+ 1 param) plist)
						xang (angle pt1 pt2)
						dis (distance pt1 pt2)
						midp (polar pt1 xang (/ dis 2))
                                        )
                                        (if (not (zerop dis))
                                        (setq
						lcnt (1+ lcnt)
						ls (list
                                                    (strcat "L" (itoa (+ (1- ni) lcnt)))
                                                    (ReplaceD (angtos xang 4 3))
                                                    (rtos (* dis CVFactor) 2 (atoi ToPrecision))
                                                    (strcat "N " (rtos (cadr pt1)) ", E "(rtos (car pt1)) )
                                                    (strcat "N " (rtos (cadr pt2)) ", E " (rtos (car pt2)))
                                                   )
						xlst (append xlst (list ls))
					);setq
                                        );
					  (and (= kword "Yes")(not (zerop dis)) 
					    (Setq Tobj
					      (vla-AddMtext *Space*
						(setq txtpt
					          (vlax-3d-point
					   	    (if (and (= (vla-get-ActiveSpace ActDoc) 0)(eq (vla-get-mspace ActDoc) :vlax-false))
						        (polar (wcs2pcs midp viewport)
							       (+ (angle (wcs2pcs pt1 viewport)(wcs2pcs pt2 viewport))(* pi 0.5))
							       (* 3 (getvar 'dimtxt))) 
						        (polar midp (+ xang (* pi 0.5)) (* 3 ts))
					            )
					          )
						);setq txtp
						0.0
					        (strcat "L" (itoa (+ (1- ni) lcnt)))
					      );vla
					    );setq Tobj
					    (vla-put-attachmentpoint Tobj acAttachmentPointMiddleCenter)
					    (vla-put-insertionpoint Tobj txtpt)
					  );and
				);progn
				);if
			)
			(setq param (1+ param))
 		);while
	);progn
	);condition

	((and (setq obj (vlax-ename->vla-object obj))
	      (setq typ (vlax-get obj 'ObjectName))
	      (member typ '("AcDb2dPolyline" "AcDbPolyline" "AcDbLWPolyline" "AcDbLine"))
	      (not (hascurve obj))
	 )
		(setq sinfo (entget obj))
			(if (= (cdr (assoc 0 (entget obj))) "LINE")
			(setq plist (list (cdr (assoc 10 sinfo))(cdr (assoc 11 sinfo))))
      			(setq plist (massoc 10 sinfo))
			);if
		(and (vlax-curve-isclosed (vlax-ename->vla-object obj))(setq plist (append plist (list (car plist)))))
      		(setq len (length plist)
			cnt 0
		);setq
		 (repeat
			(- len 1);;repeat # of segments
	        	(setq num (+ 1 lcnt);;;keep num 1 more than lcount
				pt1 (nth cnt plist);;;get beg. and end of segment
				pt2 (nth (+ 1 cnt) plist)
				xang (angle pt1 pt2);;;get angle
				dis (distance pt1 pt2);;;get distance
				midp (polar pt1 xang (/ dis 2))
				ls (list
                                     (strcat "L" (itoa (+ (1- ni) num)))
                                     (ReplaceD (angtos xang 4 3))
                                     (rtos (* dis CVFactor) 2 (atoi ToPrecision))
                                     (strcat "N " (rtos (cadr pt1)) ", E " (rtos (car pt1)))
                                     (strcat "N " (rtos (cadr pt2)) ", E " (rtos (car pt2)))
                                   )
			)
			          (if (not (zerop dis))
				   (setq
				     xlst (append xlst (list ls));;;create list of table components
				     cnt (1+ cnt);;;annalyze next point
				     lcnt (1+ lcnt)
	         		    );setq
			           );if
		
			(if (and (= kword "Yes")(not (zerop dis)))
			  (and 
			    (Setq Tobj
			      (vla-addMtext
			        *Space*
				  (setq txtpt
			          (vlax-3d-point
			            (if (and (= (vla-get-ActiveSpace ActDoc) 0)(eq (vla-get-mspace ActDoc) :vlax-false))
				      (polar (wcs2pcs midp viewport)
					     (+ (angle (wcs2pcs pt1 viewport)(wcs2pcs pt2 viewport))(* pi 0.5))
					     (* 3 (getvar 'dimtxt)))
				      (polar midp (+ xang (* pi 0.5)) (* 3 ts))
			            )
			          )
				  );setq txtpt
				  0.0
				  (strcat "L" (itoa (+ (1- ni) lcnt)))
			      );vla
			    );setq Tobj
			    (vla-put-attachmentpoint Tobj acAttachmentPointMiddleCenter)
			    (vla-put-insertionpoint Tobj txtpt)
			  );and
			);if
		);repeat
	);condition

	(progn
	  (hascurve obj)
	  (setq cen (cdr (assoc 10 (entget obj)))
		obj (vlax-ename->vla-object obj)
		pt1 (var2list (vla-get-StartPoint obj))
        	pt2 (var2list (vla-get-EndPoint obj))
		rad (vla-get-radius obj)
		dis (vla-get-arclength obj)
		ang (vla-get-TotalAngle obj)
		xang (chord-bearing obj)
		midp (polar pt1 xang (/ (distance pt1 pt2) 2))
		c (chord obj)
		ccnt (1+ ccnt)
		cls (list (strcat "C" (itoa (+ (1- ci) ccnt)))
                          (rtos (* rad CVFactor) 2 (atoi ToPrecision))
                          (rtos (* dis CVFactor) 2 (atoi ToPrecision)) 
                          (ReplaceD (angtos ang 1 4))
                          (ReplaceD (angtos xang 4 3))
                          (rtos (* c CVFactor) 2 (atoi ToPrecision))
                          (strcat "N " (rtos (cadr pt1)) ", E " (rtos (car pt1)))
                          (strcat "N " (rtos (cadr pt2)) ", E " (rtos (car pt2)))
                     )
		cxlst (append cxlst (list cls))
	  )
	(if (= kword "Yes")
	  (and
	    (Setq Tobj
	      (vla-addMtext
	        *Space*
		  (setq txtpt
	          (vlax-3d-point
	            (if (and (= (vla-get-ActiveSpace ActDoc) 0)(eq (vla-get-mspace ActDoc) :vlax-false))
		      (wcs2pcs (polar cen (angle cen midp) (+ rad (* 15 (getvar 'dimtxt)))) viewport)
		      (polar cen (angle cen midp) (+ rad (* 2 ts)))
	            )
	          )
		  );setq txtpt
		  0.0
		  (strcat "C" (itoa (+ (1- ci) ccnt)))
	      );vla
	    );setq Tobj
	    (vla-put-attachmentpoint Tobj acAttachmentPointMiddleCenter)
	    (vla-put-insertionpoint Tobj txtpt)
          );and
	);if
	);progn
);cond
);repeat

(if xlst
	(if (= kword2 "Table")
            (LCAddTable Lcomplst LTitle llst xlst)
            (LCAddLtTable Lcomplst LTitle llst xlst)
        )
);if
(if cxlst
	(if (= kword2 "Table")
            (LCAddTable Ccomplst CTitle clst cxlst)
            (LCAddLtTable Ccomplst CTitle clst cxlst)
        )
);if
	(setq *error* oerror)
	(setvar "osmode" (boole 2 (getvar "osmode") 16384))
	(setvar "clayer" ol)
        (setvar 'textsize oldts)
(vla-EndUndoMark ActDoc)
);defun
